package jiaocaiziliao

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/education/src/jiaocaiziliao/model"
)

type document struct {
	Table
	fields string `data:"subject,grade,document_type,title,content,icon,link"`
	create string `name:"create subject* grade* document_type*:select title* content* icon link" role:"teacher"`
	remove string `name:"remove" role:"teacher"`
}

func (s document) Create(m *ice.Message, arg ...string) {
	s.Table.ValueCreate(m, kit.TransArgKeys(arg, model.DOCUMENT_TYPE, model.TYPE)...)
}
func (s document) Remove(m *ice.Message, arg ...string) {
	s.Table.ValueRemove(m, arg...)
}
func (s document) List(m *ice.Message, arg ...string) {
	s.Table.ValueList(m, arg).Display("")
}

func init() { ice.TeamCtxCmd(document{}) }

type DocumentType int

const (
	DocumentBook DocumentType = iota
	DocumentPaper
)

var DocumentTypeList = map[DocumentType]string{
	DocumentBook:  "book",
	DocumentPaper: "paper",
}

func (s DocumentType) String() string { return DocumentTypeList[s] }
